<?php
ini_set('error_reporting', E_ALL);
// Logo here
define ('_LOGO', "vespa.png");
// Title here
define ('_ALBUM', "VeSPA");
// Base folder here
define ('_FOLDER', "fotos");
// Colors here (RGB values, between 30 and 225 for each)
define ('_CR', rand(30,125) );
define ('_CG', rand(30,125) );
define ('_CB', rand(30,125) );

//////////////////////////////////////////////////////////////////////////////////////
function mkdir_recursive($pathname, $mode)
 {
     is_dir(dirname($pathname)) || mkdir_recursive(dirname($pathname), $mode);
     return is_dir($pathname) || @mkdir($pathname, $mode);
 }

//////////////////////////////////////////////////////////////////////////////////////
function output_iptc_data( $image_path ) {    $ret='';
	$size = getimagesize ( $image_path, $info);        
	if(is_array($info) && isset($info["APP13"])) {    
		$iptc = iptcparse($info["APP13"]);
		if(is_array($iptc))
			foreach (array_keys($iptc) as $s) {              
			$c = count ($iptc[$s]);
			for ($i=0; $i <$c; $i++) {
				$i==$c-2 ? $fin=' & ' : $fin=', ';
				if($s=='2#025')$ret.= $iptc[$s][$i].$fin;
			}
		}
	}
// 	$ret=str_replace(chr(213),'',$ret);
	return substr($ret,0,-2);
}

//////////////////////////////////////////////////////////////////////////////////////
/* ---- Crée la miniature d'un fichier donné ---- */
function cree_mini($dossier,$fichier,$ou,$hauteur,$entrelacee) {
	# $taille contient [ largeur, hauteur, type, taille_html ]
	$taille = getimagesize("$dossier/$fichier");
	$mini_hauteur = $hauteur;
	$mini_largeur = ($taille[0]*$hauteur/$taille[1]);

	$grosse = imagecreatefromjpeg("$dossier/$fichier");
	$mini = imagecreatetruecolor($mini_largeur,$mini_hauteur);
	
	# réduction
	imagecopyresampled($mini, $grosse, 0, 0, 0, 0, $mini_largeur, $mini_hauteur, $taille[0], $taille[1]);
	imagedestroy($grosse);
	
	# écriture sur le disque
	imageinterlace($mini,$entrelacee);//entrelace pour le cache
	imagejpeg($mini, "$ou/$dossier/$fichier", 75);// 75 car c'est la qualité correcte pour la toile
	imagedestroy($mini);
}

//////////////////////////////////////////////////////////////////////////////////////
/* ---- Convertit une couleur RGB augmentée de $valeur en HEXADECIMAL ---- */
function hex_color($valeur){
		return sprintf("%02X%02X%02X", _CR+$valeur, _CG+$valeur, _CB+$valeur);
	}

//////////////////////////////////////////////////////////////////////////////////////
/* ---- Lie les dossiers à des URL ---- */
function url_dossier($dossier){
	$tab=explode('/',$dossier);
	$chemin=array_shift($tab);
	$ret='<a href="'.$_SERVER['PHP_SELF'].'">'._ALBUM.'</a>::';
	foreach ( $tab as $url ) {
		$chemin.='/'.$url;
		$ret.="<a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$chemin\">$url</a>::";
	}
	return $ret;
}
//////////////////////////////////////////////////////////////////////////////////////
/* ---- Liste les dossiers d'un dossier ---- */
function show_dossier($dossier,$file_name){
	if (!ereg ("(.*)\.", $file_name) && is_dir("$dossier/$file_name") )  //pour les dossiers . et ..
	return "<li><a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$dossier/$file_name\">$file_name</a>";
}
//////////////////////////////////////////////////////////////////////////////////////
/* ---- Affiche les photos et les dossiers d'un dossier ---- */
function show_photos($dossier,$nom,$dossierjoli){
	$mini_existe=0;			// Pas de miniatures par défaut
	$parent = substr_replace($dossier,"",strrpos($dossier,"/"));

	// Recherche d'éventuelles miniatures et de dossiers
	$dir=opendir("./$dossier");
	$echo="<UL>";
	// Tri alphabétique des fichiers
	while (false !== ($filename = readdir($dir))) $files[] = $filename;
	sort($files);//tri croissant

	// affichage des dossiers en ordre décroissant
	$dossiers=array_reverse($files);
	foreach ($dossiers as $file_name) $echo.=show_dossier($dossier,$file_name);
	is_dir("mini/$dossier") || mkdir_recursive("mini/$dossier",0770);
	is_dir("cache/$dossier") || mkdir_recursive("cache/$dossier",0770);
	closedir($dir);
	$echo.="</UL>";

	// Affichage des miniatures
	foreach ($files as $file_name)
	    	{
			$file_url = str_replace("&","ecomercial",$file_name);
	    		if (ereg ("(.*)\.(jpg|JPG|jpeg)", $file_name))
			{
				if (!file_exists("mini/$dossier/$file_name"))cree_mini($dossier,$file_name,'mini',64,0);
				$file_ogg = substr_replace($file_name, 'ogg', strlen($file_name)-3);
				if (file_exists("$dossier/$file_ogg"))
				 $file_url=substr_replace($file_url, 'ogg', strlen($file_url)-3);
			    	$echo.="<a href=\"" .$_SERVER['PHP_SELF']. "?dossier=$dossier&nom=$file_url\">
				<img src=\"mini/$dossier/$file_name\" border='0'></a>";
				$jpg_existe=1;
			}
	    		elseif (ereg ("(.*)\.(avi|mpg|mp4|mov)", $file_name))
			{
			    	$echo.="<br>VIDEO : <a href=\"$dossier/$file_name\">$file_name</a><br>";
			}
	    	}
	$echo.="</td><td bgcolor=#" .hex_color(-30). " valign =top width=520px>";

	isset($jpg_existe) ? $plein_ecran="<script> function pop(){
				var onde=\"slideshow.php?directory=$dossier\"
				winpops=window.open(onde,'','width=screen.availWidth,height=screen.availHeight,')
				}
			</script>
			<a href=\"javascript:pop()\"> ::PLEIN ECRAN:: </a>" : $plein_ecran='&nbsp';
	$debut="
		<td  colspan=2>
			<table width=100%>
				<tr>
				<td bgcolor=#" .hex_color(15). " align=left valign=center>
					$dossierjoli
				</td>
				<td bgcolor=#" .hex_color(15). " align=right>
					$plein_ecran
				</td>
				<td bgcolor=#" .hex_color(15). " align=right>
					<a href=help.php>::AIDE::</a>
				</td>
				<td bgcolor=#" .hex_color(15). " align=right>
					<a href=" .$_SERVER['PHP_SELF']. "?dossier=$parent>
					::RETOUR::</a>
				</td>
				</tr>
			</table>
		</td>
	</tr>
	<tr>
		<script>
		document.write('<td bgcolor=#" .hex_color(-30). " valign=top width=',screen.availWidth - 524,'%>')</script>";


	//////////////////////////////////////////////////////////////////////////////////////
	if ($nom!="")
	{
		$commentaire = "$dossier/" .substr_replace($nom, 'txt', strlen($nom)-3);
		if ( file_exists( $commentaire ) )readfile($commentaire);
 
 		if (ereg ("(.*)\.(jpg|JPG|jpeg)", $nom))
		{
			if (!file_exists("cache/$dossier/$nom"))cree_mini($dossier,$nom,'cache',384,1,1);
			$echo.="
				<a href='$dossier/$nom'>
				<img src='cache/$dossier/$nom' border='0'>
				</a><br>";
			$echo.=output_iptc_data($dossier.'/'.str_replace("\'","'",$nom));
		}
		else
		{
			$chemin_ogg = $dossier."/".substr_replace($nom, '', strlen($nom)-4);
			$echo.="<object data='itheora/index.php?v=$chemin_ogg&amp;t=30' type='text/html' style='width: 340px; height: 280px;'></object>";
		}
	}
	//////////////////////////////////////////////////////////////////////////////////////
	elseif (isset($jpg_existe))  {
		$echo.= "
			<script type='text/javascript'>
				function startGallery() {
					var myGallery = new gallery($('myGallery'), {
						timed: true,
						defaultTransition: 'fadeslideleft'
					});
				}
				window.addEvent('domready', startGallery);
			</script>
			<div class='content'>
				<div id='myGallery'>";
		
		foreach ($files as $file_name) {
			$ignorer = file_exists("$dossier/".substr_replace($file_name, 'ogg', strlen($file_name)-3));
			if (!$ignorer && ereg ("(.*)\.(jpg|JPG|jpeg)", $file_name)) {
				if (!file_exists("mini/$dossier/$file_name"))cree_mini($dossier,$file_name,'mini',64,0);
				if (!file_exists("cache/$dossier/$file_name"))cree_mini($dossier,$file_name,'cache',384,1);
				$echo.="
				<div class='imageElement'>
					<h3>".output_iptc_data("$dossier/$file_name")."</h3>
					<p>$file_name</p>
					<a href='$dossier/$file_name' title='ouvrir la photo' class='open'></a>
					<img src='cache/$dossier/$file_name' class='full' />
					<img src='mini/$dossier/$file_name' class='thumbnail' />
				</div>";
			}
		}
		$echo.= "</div>
		</div>";
	}
	//////////////////////////////////////////////////////////////////////////////////////
	$echo.= "</td>";
	echo $debut.$echo;
}
?>

<html>
<HEAD>
<TITLE>VeSPA</TITLE>
	<META HTTP-EQUIV="EXPIRES" CONTENT="0">
	<meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
	<link REL="shortcut icon" HREF="favicon.png" TYPE="image/x-png">
	<link rel="stylesheet" href="css/layout.css" type="text/css" media="screen" charset="utf-8" />
	<link rel="stylesheet" href="css/jd.gallery.css" type="text/css" media="screen" charset="utf-8" />
	<script src="scripts/mootools.v1.11.js" type="text/javascript"></script>
	<script src="scripts/jd.gallery.js" type="text/javascript"></script>
	<script src="scripts/jd.gallery.transitions.js" type="text/javascript"></script>
</HEAD>
<body bgcolor=#000000>
 <table border=0 align=center width=100%>
	<tr>
<?php
//LA BASE ************************************************************************************
if (!isset($_GET['dossier']) || $_GET['dossier']=="" || $_GET['dossier']==".")
	$dossier=_FOLDER;
else
	$dossier=$_GET['dossier'];

$dossierjoli=url_dossier($dossier);
$nom="";
// Protection contre les attaques par remontée d'arborescence
$dossier = str_replace("..","",$dossier);
if ( isset($_GET['nom']) ) $nom = str_replace("ecomercial","&", $_GET['nom']);
show_photos($dossier,$nom,$dossierjoli);
?>
		
	</tr>
</table>
<center><font color=#<?php echo hex_color(30);?> size=-3>

VESPA :: VEry Simple Photo Album :: Version 7.0 by <a href="mailto:jjorge EM free.fr">José JORGE</a> :: 09 Sep 2008

</font></center></body>
</html>
